package nc.impl.th;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.io.FileOutputStream;
import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.common.RuntimeEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ArrayListProcessor;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.log.NcLog;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pub.BusinessException;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.filesystem.IFileSystemService;
import nc.itf.uap.IVOPersistence;

import org.apache.commons.codec.digest.DigestUtils;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.methods.StringRequestEntity;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import nc.itf.bd.defdoc.IDefdocService;
import nc.itf.th.IThOcrService;
import nc.pub.toolkits.Toolkits;
import nc.th.redistoken.RedisTokenManager;
import nc.vo.pub.BusinessException;
import nc.vo.pub.filesystem.NCFileNode;
import nc.vo.th.ocr.OCRInvoiceVO;
import net.sf.json.JSONString;
/**
 * OCRӿʵ
 * @author Administrator
 *
 */
public class ThOcrServiceImpl implements IThOcrService{
	
	private IVOPersistence IVOPersistence = (IVOPersistence) NCLocator.getInstance().lookup(IVOPersistence.class);
	
	public String[] insert(ArrayList<?> arrlist) throws BusinessException {
		return this.IVOPersistence.insertVOList(arrlist);
	}
	
	
	@Override
	/**
	 * ȡtoken
	 */
	public String getToken(String appId,Long cid,String secret,String userid) throws HttpException, IOException, BusinessException {
		NcLog.info("=======ȡtokenʼ=======");
		//redisлȡûtoken
		String userToken = RedisTokenManager.getToken(userid);
		//tokenΪ
		if(Toolkits.isEmpty(userToken)){
			//OCRӿ
			userToken=getOcrToken(appId,cid,secret,userid);
			//浽redisʧЧʱ36000
			RedisTokenManager.setTokenTTL(userid,36000, userToken);
		}
		NcLog.info("=======token======="+userToken);
		NcLog.info("=======ȡtoken=======");
		 return userToken;
	}

	
	
	/**
	 * ϴƱ
	 * @throws Exception 
	 */
	public String uploadInvoice(String url,String token,String vdef17,String invoicename) throws Exception {
		NcLog.info("=======ϴƱʼ=======");
		File file=new File(RuntimeEnv.getInstance().getNCHome()
			      +File.separator +"uploadfile" + File.separator+ vdef17+File.separator+invoicename);
		String resmsg=httpFilePost(url,token,file);
		String id="";
		if(null!=resmsg&&resmsg.indexOf("uploading")!=-1){
			 JSONObject json = JSONObject.parseObject(resmsg);
			 JSONObject data=json.getJSONObject("data");
			 if(null!=data){
				 id=data.getString("id");
			 }else{
				 String msg=json.getJSONObject("res_base").getString("message");
				 throw new BusinessException(msg);
			 }
			
		}
		
		return resmsg;
	}



	/**
	 * OCRʶ
	 */
	@Override
	public String ocrIdentification(String pathUrl, String token,String data) {
		// TODO Զɵķ
		 NcLog.info("=======ƱOCRʶʼ=======");
		 JSONObject json = JSONObject.parseObject(data);
		 JSONObject jsonobject = new JSONObject();
         jsonobject.put("image_index", json.getJSONObject("data").getString("id"));
         jsonobject.put("fileTypeStr", json.getJSONObject("data").getString("fileType"));
         jsonobject.put("flag", "13");
         jsonobject.put("is_save", "0");
         jsonobject.put("is_sync", "1");
         jsonobject.put("ocrMap","");
         jsonobject.put("operate_type",0);
		 return doPost(pathUrl,token,jsonobject.toString());
	}
	
	
	/**
	 * OCRʶݱݿ
	 * @throws BusinessException 
	 */
	public void insertOCRdataInfo(ArrayList<OCRInvoiceVO> vos) throws BusinessException {
		insert(vos);
	}
	
	

	public String getOcrToken(String appId,Long cid,String secret,String userid)  throws HttpException, IOException, BusinessException{
    	HttpClient httpClient = new HttpClient();
    	httpClient.getHttpConnectionManager().getParams().setConnectionTimeout(5000);
        httpClient.getHttpConnectionManager().getParams().setSoTimeout(5000);
        PostMethod postMethod = new PostMethod("https://api.mypiaojia.com/api/invoiceApi/token/buildToken");
        postMethod.setRequestHeader("content-type", "application/json");
        postMethod.setRequestHeader("appkey", appId);
        long l = System.currentTimeMillis();
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("role", 1);
        map.put("name", "dmy06");
        map.put("name", "dmy06");
        map.put("userId", userid);//OAûϵûid 2108
        map.put("cid", cid);
        String s1 = JSONObject.toJSONString(map);
        String s2 = s1 + "&time=" + l + "&secret="+secret;
        String newMd5 = DigestUtils.md5Hex(s2);
        String s4 = s1 + "&time=" + l + "&md5=" + newMd5;
        RequestEntity entity = new StringRequestEntity (s4 ,"application/json" ,"UTF-8");
        postMethod.setRequestEntity(entity);
        httpClient.executeMethod(postMethod);
		String responseMsg = postMethod.getResponseBodyAsString().trim();
		//ؽ{"data":"WEAPPe8Ke9pFzz9fbZ3qCcN6itq1zLHCKOgPmXHz6uIg8eOg","actionMsg":{"code":0,"message":"ִгɹ"}}
 //       System.out.println("ؽ"+ responseMsg);

		 JSONObject json = JSONObject.parseObject(responseMsg);
		 String token=json.getString("data");
		 String status=json.getString("status");
		 //tokenֵ־ļ
		 NcLog.info("token:"+token);
		 
		 if(null!=status){
			 throw new BusinessException(responseMsg);
		 }
		 
		 return token;
	  }
	
	


	 public  String httpFilePost(String uploadUrl,String token, File file) throws Exception {
		 
		//File file = new File(file);
		 String LINEND = "\r\n";
		 String boundary = UUID.randomUUID().toString();
		 FileInputStream fileInputStream = new FileInputStream(file);
	     URL url = new URL(uploadUrl);
	     HttpURLConnection httpURLConnection = (HttpURLConnection) url.openConnection();
	     httpURLConnection.setDoInput(true);
	     httpURLConnection.setUseCaches(false);
	     httpURLConnection.setDoOutput(true);
	     httpURLConnection.setRequestMethod("POST");
	     httpURLConnection.setRequestProperty("connection", "keep-alive");
	     httpURLConnection.setRequestProperty("Charsert", "UTF-8");
	     httpURLConnection.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);
	     httpURLConnection.setRequestProperty("token", token);
	     httpURLConnection.setRequestProperty("Accept","*/*");
	     DataOutputStream outStream = new DataOutputStream(httpURLConnection.getOutputStream());
         StringBuilder stringBuilder = new StringBuilder();
         stringBuilder.append("--").append(boundary).append(LINEND);
         stringBuilder.append("Content-Disposition: form-data; name=\"file\"; filename=\"" + file.getName() + LINEND);
         stringBuilder.append("Content-Type: " + HttpURLConnection.guessContentTypeFromName(file.getName()) + LINEND);
         stringBuilder.append("Content-Transfer-Encoding: binary"+ LINEND);
         stringBuilder.append(LINEND);
 //        outStream.write(stringBuilder.toString().getBytes());
         outStream.writeUTF(stringBuilder.toString());
    	 InputStream is = new FileInputStream(file);
    	 byte[] buffer = new byte[1024];
    	 int len = 0;
    	 while ((len = is.read(buffer)) != -1){
    		 outStream.write(buffer, 0, len);
    	 }
    	 is.close();
    	 outStream.write(LINEND.getBytes());
    	 byte[] end_data = ("--" + boundary + "--" + LINEND).getBytes();
    	 outStream.write(end_data);
    	 outStream.flush();
         fileInputStream.close();
         String response = readStream(httpURLConnection.getInputStream());
         outStream.close();
         httpURLConnection.disconnect(); 
         NcLog.info("Ʊϴjson:"+response);
		 return response;
			
		}
		 
		 
		 private  String readStream(InputStream inputStream) throws IOException {
		        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
		        byte[] buffer = new byte[1024];
		        int bytesRead;
		        while ((bytesRead = inputStream.read(buffer)) != -1) {
		            outputStream.write(buffer, 0, bytesRead);
		        }
		        byte[] bytes = outputStream.toByteArray();
		        String result = new String(bytes, "UTF-8");
		        outputStream.close();
		        return result;
		    }



		 public  String doPost(String pathUrl, String token,String data){
			OutputStreamWriter out = null;
	        BufferedReader br = null;
	        String result = "";
	        try {
	        	URL url = new URL(pathUrl);
	        	//򿪺url֮
	            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
	            //趨ķΪ"POST"ĬGET
	            //postgetĲ֮ͬpostĲǷURLִ棬Ƿhttpڡ
	            conn.setRequestMethod("POST");
	  
	            //30ӳʱ
	            conn.setConnectTimeout(30000);
	            //30ȡʱ
	            conn.setReadTimeout(30000);
	  
	            // ǷhttpUrlConnectionΪpost󣬲ҪhttpڣҪΪtrue, Ĭfalse;
	            conn.setDoOutput(true);
	            // ǷhttpUrlConnection룬Ĭtrue;
	            conn.setDoInput(true);
	  
	            // Postʹû
	            conn.setUseCaches(false);
	  
	            //ͨõ
	            conn.setRequestProperty("accept", "*/*");
	            conn.setRequestProperty("connection", "Keep-Alive");  //άֳ
	            conn.setRequestProperty("Content-Type", "application/json;charset=utf-8");
	            conn.setRequestProperty("token", token);
	  
	            //ӣurl.openConnection()˵ñҪconnect֮ǰɣ
	            conn.connect();
	  
	            /**
	             * 룬ǵõhttpӿ
	             */
	            //ȡURLConnectionӦ
	            //˴getOutputStreamĽconnect(ͬconnect()ڿвconnect()Ҳ)
	            out = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
	            //
	            out.write(data);
	            //flushĻ
	            out.flush();
	  
	            /**
	             * Ĵ൱ڣȡõhttpӿں󷵻صĽ
	             */
	            //ȡURLConnectionӦ
	            InputStream is = conn.getInputStream();
	            //һַ
	            br = new BufferedReader(new InputStreamReader(is,"UTF-8"));
	            String str = "";
	            while ((str = br.readLine()) != null){
	                result += str;
	            }
	         //   System.out.println(result);
	            
	           /* JSONObject json = JSONObject.parseObject(result);
	            //ȡҪ
	            JSONObject datajson = json.getJSONObject("data");
	            System.out.println("datajson===="+datajson.toString());
	            JSONArray infosjson = datajson.getJSONArray("infos");
	            System.out.println("infosjson===="+infosjson.toString());
	            
	            for (Object infos : infosjson) {
	            	JSONObject infosObject =(JSONObject)infos;
	                String total=infosObject.getJSONObject("info").getJSONObject("comm_info").getJSONObject("price").getString("total");
	                System.out.println("total===="+total);
	            }*/
	            
	            //ر
	            is.close();
	            //Ͽӣdisconnectڵײtcp socketӿʱжϣڱ߳ʹþͲжϡ
	            conn.disconnect();
	        }catch (Exception e) {
	            e.printStackTrace();
	        }finally {
	            try {
	                if (out != null){
	                    out.close();
	                }
	                if (br != null){
	                    br.close();
	                }
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
	        }
	        
	        NcLog.info("ƱOCRʶ𷵻json:"+result);
	        
			return result;
		 }
		 
		 /**
			 * 
			 *  Ʊ浽ļ
			 *  vdef17     Ʊ
			 *  fileName Ʊ
			 *  file     ѡеķƱ
			 * @throws IOException 
			 */
			public String saveUploadFile(String vdef17,String fileName,byte[] bytes) throws Exception {
		/*		NcLog.info("=====Ʊ濪ʼ=====");
				String filepath =  RuntimeEnv.getInstance().getNCHome()
					      +File.separator +"uploadfile" + File.separator+ vdef17; // ļ·
				NcLog.info("ļ·"+filepath);
				NcLog.info("ԭļ·"+file.getPath());
				File folder = new File(filepath);
				if(!folder.exists() && !folder.isDirectory()){
					folder.mkdirs();
				}
				String newFileName = filepath + File.separator + fileName;
				NcLog.info("ļ·"+newFileName);
				FileOutputStream outputStream = new FileOutputStream(newFileName);
				NcLog.info("=====FileOutputStream=====");
				FileInputStream fis = new FileInputStream(file);
		        byte[] buffer = new byte[1024];
		        int len;
		        NcLog.info("=====ȡƱϢʼ=====");
		        while ((len = fis.read(buffer)) != -1) {
		            outputStream.write(buffer, 0, len);
		        }
		        NcLog.info("=====ȡƱϢ=====");
		        outputStream.close();
		        fis.close();
		        NcLog.info("=====Ʊ=====");*/
				
			//	byte[] bs = Base64.decode(file.trim());
				
				NcLog.info("=====Ʊ濪ʼ=====");
			//	NcLog.info("=====bytes:"+bytes.length+"=====");
				String filepath =  RuntimeEnv.getInstance().getNCHome()
					      +File.separator +"uploadfile" + File.separator+ vdef17; // ļļ
				String newFileName = filepath + File.separator + fileName;
				NcLog.info("ļ·"+newFileName);
				
				String savefilepath=SaveTempFile(filepath,newFileName,bytes);
//				Upload(vdef17,savefilepath,newFileName,InvocationInfoProxy.getInstance().getUserId());
				
				return savefilepath;
				
			 }
			
			
			
			/**
			 * ļ
			 * 
			 * @param filepath  ļ·
			 * @param fileName  ļ·
			 * @param bs  ļ
			 * @return  ļ·
			 * @throws Exception 
			 */
			public String SaveTempFile(String filepath,String fileName,byte[] bytes) throws Exception  {
				FileOutputStream fos = null;
				BufferedOutputStream bos=null;
				try {
					File folder = new File(filepath);
					if(!folder.exists() && !folder.isDirectory()){
						folder.mkdirs();
					}
					fos = new FileOutputStream(fileName);
					bos = new BufferedOutputStream(fos);
					bos.write(bytes);
				} catch (FileNotFoundException e1) {
					// TODO Զɵ catch 
					e1.printStackTrace();
					NcLog.info("淢ƱFileNotFoundException쳣"+e1.getMessage());
					throw new Exception("淢ƱFileNotFoundException쳣"+e1.getMessage());
					
				} catch (IOException e) {
					// TODO Զɵ catch 
					e.printStackTrace();
					NcLog.info("淢ƱIOException쳣"+e.getMessage());
					throw new Exception("淢ƱIOException쳣"+e.getMessage());
				}finally {
					if (bos != null) {
						try {
							bos.close();
						} catch (IOException e) {
							e.printStackTrace();
							NcLog.info("رbos쳣"+e.getMessage());
							throw new Exception("رbos쳣"+e.getMessage());
						}
					  }
					}
					
					if (fos != null) {
						try {
							fos.close();
						} catch (IOException e) {
							e.printStackTrace();
							NcLog.info("رfos쳣"+e.getMessage());
							throw new Exception("رfos쳣"+e.getMessage());
						}
					}
					
				       return filepath;
			      }
			
	
			
			/**
			 * NCļϴ
			 * @param parentPath pk_jkbx
			 * @param newFile ļ·
			 * @param filename ļ
			 * @param user_code 
			 * @return 0ʾϴɹ,-1ʾʧ
			 * @throws BusinessException 
			 * @throws IOException 
			 */
			public int Upload(String parentPath, String filepath, String filename,String user_code) throws BusinessException, IOException {
				NcLog.info("============ֹظϴͬƵĸʼ============");
				QueryFile(parentPath, filename);
				NcLog.info("============ֹظϴͬƵĸ============");
				File file = new File(filepath);
				NcLog.info("ļ·file"+file.getPath());
				Long fileLen = file.length();
				String creator = user_code;
				NCFileNode node = null;
				InputStream fileinput = null;
				try {
					fileinput = new FileInputStream(file);
					NcLog.info("FileInputStream"+fileinput);
					IFileSystemService service = (IFileSystemService) NCLocator
							.getInstance().lookup(IFileSystemService.class);
					NcLog.info("ӿserviceʼ"+service);
					node = service.createNewFileNodeWithStream(parentPath, filename,
							creator, fileinput, fileLen);
					NcLog.info("ӿservice"+node);
				} catch (FileNotFoundException e) {
					e.printStackTrace();
					NcLog.info("FileNotFoundExceptionʧܣ"+e.getMessage());
					throw new FileNotFoundException();
				} catch (IOException e) {
					e.printStackTrace();
					NcLog.info("IOExceptionʧܣ"+e.getMessage());
					throw new IOException();
				} catch (BusinessException e) {
					e.printStackTrace();
					NcLog.info("BusinessExceptionʧܣ"+e.getMessage());
					throw new BusinessException();
				} finally {
					try {
						fileinput.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				if (node == null) {
					NcLog.info("-1ʾʧܣ"+""+-1+"");
					return -1;
				}
				NcLog.info("0ʾϴɹ"+""+0+"");
				return 0;
				
			}
		
			/**
			 * ֹظϴͬƵĸ
			 * 
			 * @param parentPath
			 *            
			 * @param filename
			 *            ļ
			 * @throws BusinessException 
			 */
			public void QueryFile(String parentPath, String filename) throws BusinessException  {
				try {
					String path = parentPath + "/" + filename;
					IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
					String sql = "select filepath from sm_pub_filesystem where filepath = '"
							+ path + "'";
					@SuppressWarnings("unchecked")
					List<Object[]> filelist = (List<Object[]>) iuap.executeQuery(sql,
							new ArrayListProcessor());
					if (filelist != null && filelist.size() > 0) {// иɾ
						IFileSystemService service = (IFileSystemService) NCLocator
								.getInstance().lookup(IFileSystemService.class);
						String[] arg = new String[] { path };
						service.deleteNCFileNodes(arg);
					}
				} catch (DAOException e) {
					e.printStackTrace();
					NcLog.info("=====DAOExceptionֹظϴͬƵĸ====="+e.getMessage());
					throw new DAOException();
				} catch (BusinessException e) {
					e.printStackTrace();
					NcLog.info("=====BusinessExceptionֹظϴͬƵĸ====="+e.getMessage());
					throw new BusinessException();
				}
			}
		
			/**
			 * ȡhome·
			 */
			public String getNCHomePath() {
			
				return RuntimeEnv.getInstance().getNCHome();
			}


			/**
			 * ɾhomeӦķƱ
			 */
			public Boolean deleteFile(String filepath)  {
				 NcLog.info("=====ɾhomeӦķƱʼ=====");
				//ɾhomeƱļĶӦƱ add by ZTH
				String deletefilepath =  RuntimeEnv.getInstance().getNCHome()
					      +File.separator +"uploadfile" + File.separator+ filepath; // ļ·
				
				 File file = new File(deletefilepath);
				 
				 Boolean bo= file.delete();
				 NcLog.info("=====ɾhomeӦķƱ=====");
				 return bo;
				 
				
			}


			/**
			 * ɾ̫ĳԶ嵵ͣ
			 * @throws BusinessException 
			 */
			public DefdocVO[] enablestateDate(String filepath,String[] filname) throws BusinessException {
				 NcLog.info("=====ĳԶ嵵ͣÿʼ=====");
				 DefdocVO[] deletevos=QryDefdocvoInfo(filname[1]);
				 IDefdocService idefservice = NCLocator.getInstance().lookup(IDefdocService.class);
				 DefdocVO defvo =deletevos[0];
				 defvo.setAttributeValue("enablestate", 3);//ͣ
				 DefdocVO[] defdocVOs= idefservice.updateDefdocs(InvocationInfoProxy.getInstance().getGroupId(),deletevos);
				 NcLog.info("=====ĳԶ嵵ͣý=====");
				 return defdocVOs;
			}
			
			
			private DefdocVO[]  QryDefdocvoInfo(String name){
		    	String sql = "select * from  bd_defdoc where  nvl(dr, 0) = 0 and pk_defdoclist="
		    			+ "(select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0) and memo='" + name + "' ";
		    	ArrayList<Object> arrayvos=null;
		    	try {
		    		IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
					arrayvos=(ArrayList<Object>) iuap.executeQuery(sql, new BeanListProcessor(DefdocVO.class));
				} catch (BusinessException e) {
					// TODO Զɵ catch 
					e.printStackTrace();
				}
		    	
		    	if (arrayvos==null) {
		  			return new DefdocVO[0];
		  		}else {
		  			return arrayvos.toArray(new DefdocVO[0]);
		  		}
		    	
		    }


			/**
			 * ȡ"+vdef17+"ļзƱ
			 */
			public List<String> getInvoiceInfo(String vdef17) {
				String filepath =  RuntimeEnv.getInstance().getNCHome()
					      +File.separator +"uploadfile" + File.separator+ vdef17; // ļ·
				List<String> filewjlis=getFileNames(filepath);
				
				return filewjlis;
			} 
		 
			/**
		     * õļ
		     *
		     * @param path ·
		     * @return {@link List}<{@link String}>
		     */
		    private  List<String> getFileNames(String path) {
		        File file = new File(path);
		        if (!file.exists()) {
		            return null;
		        }
		        List<String> fileNames = new ArrayList<String>();
		        return getFileNames(file, fileNames);
		    }

		/**
		     * õļ
		     *
		     * @param file      ļ
		     * @param fileNames ļ
		     * @return {@link List}<{@link String}>
		     */
		    private  List<String> getFileNames(File file, List<String> fileNames) {
		        File[] files = file.listFiles();
		        for (File f : files) {
		            if (f.isDirectory()) {
		                getFileNames(f, fileNames);
		            } else {
		                fileNames.add(f.getName());
		            }
		        }
		        return fileNames;
		    }
	
}
